FFFTP version history.

Changes in Ver.2.00
--------------------

This list includes changes applied by automatic software updates.

-- Changed the checking interval of automatic software updates from 7 days to
   30 days.

-- Added a feature to export settings as WinSCP INI format.

-- Added an option to ignore addresses returned with PASV mode.
   Please use this for connection to hosts that have incorrect settings.

-- Added an option to add information to files as obtained from the Internet
   when they are downloaded.
   This will display a warning when downloaded executable files etc. are about
   to be opened.
   This feature is enabled by default.

-- Fixed bugs that the focus is lost after keyboard operation.

-- Made it show the logged in user name on the title bar.

-- Fixed bugs that connecting to hosts that supports only deprecated encryption
   methods is unable.

-- Fixed bugs that local files with abnormal timestamps cause crashes.

-- Supported proxy connection for automatic software update.

-- Fixed bugs that sometimes Overwrite if newer does not work.

-- Fixed bugs that it hangs up during drag-and-drop.

-- Resolved flickering of the window caused by a side effect of bug
   countermeasure.

-- Implemented Server Name Indication.
   This solves the problem that it cannot connect to some shared servers.

-- Changed to check Subject Alternative Names at validation of SSL/TLS
   certificates.

-- Fixed bugs that sometimes it cannot reconnect after transfer failure.

-- Fixed bugs that the queue of file transfer is not released on disconnection.

-- Fixed bugs that sometimes Force Exit does not work while transfer.

-- Fixed bugs that the behavior is strange after clicking Stop button.

-- Fixed bugs that transfer fails at a host right after disconnection from
   another host whose number of simultaneous connections is more than 1.

-- Updated OpenSSL.

-- Updated SSL/TLS root CAs.

Changes in Ver.1.99a
--------------------

The lists of this and newer versions include changes applied by automatic
software updates.

-- Supported specification changes of the server for automatic software update.
   Please update your copy of FFFTP to this version manually because older
   versions cannot update automatically now.

-- Fixed bugs that it could not display some file names if its encoding was
   other than UTF-8.

-- Fixed bugs that an useless dialog was popped up on ZIP versions while
   settings were imported from the registry.

-- Updated OpenSSL.

-- Updated SSL/TLS root CAs.

Changes in Ver.1.99
--------------------

-- Tested on Windows 8.1 (32bit/64bit).

-- Tested on Windows 10 (32bit/64bit).

-- 64bit version is now available.
   This works around the certain restriction on 64bit Windows.

-- Added the feature of automatic software update (Windows XP SP3 or later
   only).
   It will connect to the dedicated server to check whether there are updates
   every 7 days by default, and then confirm whether to apply them.

-- Added a feature to encrypt the all settings with the master password.
   This prevents malwares and third parties from skimming personal information.
   Please note that 1.98g or former versions cannot read encrypted settings.
   This feature is disabled by default.

-- Fixed bugs that the apprication did not start when the INI file was modified
   and BOM was inserted in it.

-- Fixed bugs that user names which were sent to hosts were always encoded into
   UTF-8.

-- Fixed bugs of recognition of MLSD responses that include uppercase letters.

-- Added an option to disable automatic refresh of the local view.

-- Added an option to dispose old logs automatically.

-- Supported UTF-8 HFS+ file name encoding (Windows Vista or later only).

-- Improved automatic detection of Kanji code of filenames.

-- Fixed bugs of Select dialog.

-- Changed to confirm how the settings will be saved when the settings of a
   future version exist in the registry.

-- Changed to display file sizes with units of GB or larger.

-- Changed to display the encryption status of the current connection.

-- Changed to display the progress of file transfer on the taskbar (Windows 7
   or later only).

-- Added a function to move remote files to their parent directory.

-- Supported high DPI displays.
   The interface such as the menu will look smooth on high DPI displays.

-- Added a feature to export settings as FileZilla XML format.

-- Added an option not to use weak encryption methods for each host.
   This refuses SSL 3.0 or older and encryption algorithms whose keys are
   shorter than 128 bits.
   This feature is enabled by default.

-- Added the default settings to the host list.
   This is used for the initial state of new hosts and Quick Connect.

-- Added an option to abort file transfer if failed in obtaining file lists
   before it.
   This feature is enabled by default.

-- Changed to enable reconnection after transfer errors by default.

-- Fixed bugs to fail in controlling UPnP with simultaneous connections.

-- Fixed bugs to crash if certain operations are performed immediately after
   drag-and-drop from the remote file view.

-- Fixed bugs to fail in recognizing file names that contain 2 or more spaces
   in Windows Server 2008 R2 file list format.

-- Added an option not to save the user name and password of the firewall.

-- Fixed bugs to disturb the view after resizing of a dialog.

Changes in Ver.1.98g2
--------------------

-- Fixed the issue that the installer was contaminated by a file for the ZIP
   version.

-- Fixed bugs that the message indicating that SSL/TLS root CAs had been
   modified was displayed.

Changes in Ver.1.98g1
--------------------

-- Updated OpenSSL.

-- Updated SSL/TLS root CAs.

Changes in Ver.1.98g
--------------------

-- Tested on Windows 8 (32bit/64bit).

-- Added an option to overwrite files only if they are larger than their
   originals.

-- Added an option to set a local Kanji code chosen at startup.

-- Changed to directly show Browse For Folder dialog on clicking Change Folder
   button in the local side.

-- Improved conditions to send commands for keep alive.
   Less likely to fail such as when deleting a large number of files.

-- Supported the file list format of uClinux.

-- Fixed bugs that unexpected files were deleted when removing a directory
   which includes symbolic links.

-- Added an option to handle of seconds of time stamps.

-- Added an option to display file permissions in numbers.

-- Added an option to reconnect after transfer errors.
   This may work around the limitations on the transfer amount or time per
   session.

-- Fixed bugs that the file transfer might be aborted on operating the main
   window if reusing sockets of the main window was enabled and you operated
   the main window while files were transferring.

-- Added an option to control NATs with Universal Plug and Play on non PASV
   mode connections (Windows XP or later only).
   This allows computers that are under NATs that have private IP addresses to
   listen for connections with PORT commands.

-- Supported the file list format of Windows Server 2008 R2.

-- Added an option to turn on/off stateful FTP filtering of Windows Firewall
   (Windows Vista or later only).
   This may improve communication conditions in the case that FTPES connection
   used to be interrupted or that the computer has only private IP addresses.

Changes in Ver.1.98f
--------------------

-- Fixed bugs of incorrect behavior of Select dialog.

-- Added an option for retaining timestamps on uploading.

-- Changed to require the current master password before changing it.

-- Fixed bugs that files in a temporary folder was shown in local file list
   after files in a host had been dropped into other applications.

-- Shortened intervals between keep alive packets.

-- Fixed bugs that UI was unlocked in some cases when commands were being sent
   over the socket of main window.

-- Added extensions of files that will be transferred in ASCII mode.

-- Extended command line options.

-- Changed to try SSL when a host cannot recognize TLS on FTPS Explicit.

-- Fixed bugs that corruption was caused when strings were converted from
   UTF-8 to Shift_JIS on Windows Vista or later.

-- Changed to refresh the local view automatically when files in the current
   directory are modified.

Changes in Ver.1.98e
--------------------

-- Fixed bugs that an inputted password is ignored if failed in login.

-- Fixed bugs to crash under multicore CPU environment.

-- Changed the location of temporary files.
   This resolves interference in file list caches between instances of FFFTP.

-- Supported the file list format of linux-ftpd.

-- Added a feature to show file icons on local file list view.

-- Supported HP NonStop Server (provided by Yuji Tanaka).

-- Fixed bugs of missing some comannds at reconnecting
   (provided by Yuji Tanaka).

-- Fixed several messages (provided by Moriguchi Hirokazu).

-- Fixed bugs of setting incorrect file timestamps by MDTM command.

-- Fixed bugs that drag-and-drop was enabled during deleting files.

-- Enhanced error handling of transferring files.

-- Enabled reusing sockets of the main window by default.

-- Fixed bugs that attributes of existing files were changed on uploading with
   renaming by hosts.

-- Fixed bugs of hanging on exit in some cases.

-- Fixed bugs of hanging at accessing non-existent directories without full
   path.

-- Changed behavior of Auto of network type selection.
   Name resolution and connection will be performed at same time on IPv4 and
   IPv6, and whichever finished earlier will be used.

-- Disabled saving settings in the registry about ZIP version copies.
   To save in the registry, please remove "portable" the file.

-- Fix bugs of corruption of the extensions columns.

-- Added support for some MLSD responses that do not conform to RFC 3659.

Changes in Ver.1.98d
--------------------

-- MLSD command became used for retrieving filenames on appropriate hosts.
   That is helpful for hosts that do not return filenames properly.

-- Enhanced communication routines to reduce waiting time.

-- Changed to display responses from hosts after decoding as Kanji code of
   filenames.

-- Fixed bugs of arbitrary code execution in saving registry settings to a
   file.

-- Fixed bugs of launching wrong files if correct ones contain no extensions.

-- Internet Protocol Version 6 became available.
   IPv6 will be used when name resolution for IPv4 is unavailable by default.

-- Changed to detect encoding of strings in INI file automatically.

-- Changed to verify SSL/TLS certificates with root CAs in FTPS connections.
   Please modify "ssl.pem" in PEM format if you want to update root CA list.

-- Added a feature to send commands for keep alive.
   This is disabled by default.

-- Reduced chance of stopping transfer when numerous files are transfered.

-- Added a feature to retry transfering files if failed.

-- Enhanced automatic detection of Kanji code of filenames.

Changes in Ver.1.98c
--------------------

-- Changed to connect to hosts with Punycode if their names contain
   international characters.

-- Fixed bugs of resetting the current directory on reconnection.

-- FTP over Implicit SSL/TLS became available.

-- Fixed bugs of corruption on resuming downloading files larger than 4GB.

-- Fixed communication routines to match specifications of Windows 2000.

-- Enhanced responses of aborting.

-- Fixed bugs of INI file backup.

-- Fixed bugs of handling multi-byte character filenames on hosts whose Kanji
   code of filenames are Shift_JIS.

-- Added support for UTF-8 (without BOM) conversion under ASCII mode transfer.
   UTF-8 added in 1.98 was renamed UTF-8 BOM.

-- Changed size and layout of the window at the first run.

-- Added settings to reuse connection of the main window for transfer threads.
   This may allow to transfer files successfully as with 1.97b or earlier,
   but sometimes may cause some errors.

Changes in Ver.1.98b
--------------------

-- Added the feature that prevents from loading untrustworthy DLLs.
   It reduces the chance of being intercepted or tampered with passwords and
   data.
   Please add --protect to command line options to use this feature.
   If slowdown or crash occured, you may adjust the protection level with
   --protect-medium or --protect-low option.

-- Changed to confirm SSL certificate on first time connection with FTPS.

-- Changed to reuse SSL sessions of FTPS control connection.

-- Reduced chance of crash when numerous files are transfered.

-- Fixed bugs of copying URL to clipboard.

-- Added support for migration from 1.97b or earlier through INI file.

-- Added settings to disallow unencrypted FTP.

-- Fixed bugs of arbitrary code execution from the context menu.

Changes in Ver.1.98a
--------------------

-- Fixed bugs of character corruption of host list dialog.

-- Fixed bugs of playing sound whose filename contains multi-byte characters.

-- Fixed bugs of printing logs of transfer rate.

-- Changed behavior of filename encoding settings migration from 1.97b.

-- Reduced chance of failure of connecting to hosts that do not support FTPS.

-- Changed behavior of entering a new master password.

-- Removed the log size limit.

Changes in Ver.1.98
--------------------

-- SourceForge.JP took over the development.
   Thanks Mr. Sota for FFFTP the most sophisticated FTP client.

-- Fixed bugs to crash under multicore CPU environment.

-- Changed internal characters into UTF-8.

-- JRE32.DLL became unavailable. (It does not support UTF-8.)

-- Shift_JIS, JIS, EUC and UTF-8 conversion under ASCII mode transfer became
   available.

-- Changed default Kanji code of filenames on hosts into UTF-8.

-- Filenames that depend Unicode characters can be treated.

-- Disabled file list cache by default.

-- FTP over Explicit SSL/TLS became available.
   Passwords, user names and files are encrypted on the connections to
   appropriate hosts.

-- Replaced UTF-8N with UTF-8. (They are identical in this case.)

-- Added the simultaneous connections feature up to 4.

Changes in Ver.1.97b
--------------------

-- Fixed Drag & Drop to the Explorer does not works when select multiple files
   or folders.


Changes in Ver.1.97a
--------------------

-- Fixed when your password is longer than 32 characters, FFFTP saves only
   first 32 characters.

-- Fixed FFFTP causes application error on Windows 2000.

Changes in Ver.1.97
-------------------

-- Now you can use master password.
   This function is made by Gengen-san. Thanks.
   When you use this virsion first, set master password from following menu.
    File -> Settings -> Change Master password

-- Now passwords are encrypted with AES.
   This function is made by Moca-san. Thanks.

Changes in Ver.1.96d
--------------------

-- Fixed IBM Extended Kanji Code was not converted when host's Kanji code 
   was set to EUC or JIS.

-- Fixed FFFTP reacts when user presses some keys (ex. BackSpace key) on 
   the help window.

Changes in Ver.1.96c
--------------------

-- Fixed Directory Traversal Vulnerability.

Changes in Ver.1.96b
--------------------

-- Change font of the file move confirmation dialog.

Changes in Ver.1.96a
--------------------

-- Supports file list which has one space character in a group name.

Changes in Ver.1.96
--------------------

-- The confirmation dialog is displayed when move file on the host.
   This setting can be changed.
   (Options - Settings - Operation)

-- Fixed FFFTP sometimes freeze when user clicks both mouse buttons on the 
   toolbar. (Thank you sunasunamix-san.)

-- Fixed FFFTP works incorrect when drop files to the title line of the file 
   list of the detailes mode.

Changes in Ver.1.95
--------------------

This version is modified by miau-san.

-- Move focus to the address bar by the ALT+D key.

-- Move focus from the address bar to the file list by the TAB key.

-- Change transfer mode (ASCII -> BINARY -> AUTO) by the Ctrl+M Key.

-- Focus top of the file list immediately after reading the file list.

-- Disable accelerator key while reading the file list.

-- If Veiwer2 or Viewer3 (on the tool setting window) prefixed "d ", it 
   assumed differential viewer. 
   If you select one file on the host file list and start the differential 
   viewer, FFFTP carries two file name to the viewer, one is the file name 
   on the host side and the other is the same file name on the local side.

-- Fixed unexpected disconnect when download is error because of local file 
   is read only.

-- Show notify dialog when download destination local file is read only.

Changes in Ver.1.94a
--------------------

-- Change temporary file handling while drag and drop. (Yutaka Hitrata-san)

-- Disable FFFTP main window operation while drag and drop. 
   (Yutaka Hitrata-san)

Changes in Ver.1.94
--------------------

-- Yutaka Hirata-san imprements OLE Drag & Drop using with nakka-san's 
   library. Now you can drag and drop from FFFTP to the exploler.

-- Yutaka Hirata-san imprements file move function in the host side file
   list window. Now you can move files to the child folder.

Changes in Ver.1.93
--------------------

-- Added setting of UTF-8N encoding.
-- Show application menu when SHIFT-F10 key is pressed.

Changes in Ver.1.92c
--------------------

-- Expand transfer buffer size to increase speed.

Changes in Ver.1.92b
--------------------

-- Fix 'Save settings to file' and 'Load settings from file' function does 
   not work on Windows Vista.

Changes in Ver.1.92a
--------------------

-- Use LIST command to get file names from server.
-- Use PASV mode default.
-- Anonymous FTP sites are no longer registerd when start the FFFTP first.

Changes in Ver.1.92
--------------------

-- Fixed application error on PASV mode.
-- Fixed pathname length was limited by the windows size which above on the 
   file list window.
-- Support file list format of Chinese Solaris.
-- Added setting of replace @ by the any character on Firewall.
-- Fixed write to registory unexpectedly when INI file which specified by 
   the '-n' option is not exist.
-- Now support "Koushin Fuutauk".

Changes in Ver.1.91
--------------------
-- Fixed Timezone displayed erroneus.
-- Support ShibaSoku WL Series file list format. (Set Host Type on the Host 
   Setting Window.)

Changes in Ver.1.90
--------------------
- Transfer speed improved.
- Add new firewall type. ("USER FW user:FW password@host")
- Fixed file size diaplayed erroneus when over 2 giga bytes.
- Improve download abortion process.
- Now file size divides and diaplays every 3 figure.
- Remove drive names from file list.
- Fixed "Load setting from file" command failes when folder name has space
  character. (such as "My Documents")
- Turn on "Confirm deletions during Mirror Upload" option switch by default.

Changes in Ver.1.89b
--------------------
- Fixed Mirror Upload / Mirror Download bug.

Changes in Ver.1.89a
--------------------
- Fixed file list not refreshed after upload.

Changes in Ver.1.89
--------------------
- Transfer speed improved.
- Fixed Transfer Status Window didn't close after the transfer complete.
- Fixed FFFTP was stalled when received unexpected PASV server message.
- Fixed server message processing.
- Add "Load Setting from File" menu.
- Support Agilent Logic Analyzer. (Set Host Type on the Host Setting Window.)

Changes in Ver.1.88b
--------------------
- Refine dialog and menu messages. (Thank you Mr.Jim.)

Changes in Ver.1.88a
--------------------
- Fixed "Cannot remove FFFTP" error message diaplayed.

Changes in Ver.1.88
-------------------
- Change to use the Registory to save settings when run first.
- Add Save Serrings function.
  (File -> Settings -L Save settings to file)
- Now max 40 characters Owner name is displaied on file list.
- Open folder when drag & drop a file to local file list from the explorer.
- Page scroll when SHIFT + Mouse Wheel.
- Fixed mouse wheel scroll didn't work when multi monitor.
- Fixed noise displaied around the file list window.

Changes in Ver.1.87a
--------------------
- Fixed forget bookmark.

Changes in Ver.1.87
--------------------
- Fixed no dialup entry diaplayed on Windows9x.
- Reconnect automatically when oprate by the user after disconnected cause 
  of timeout from the host.

Changes in Ver.1.86a
--------------------
- Fixed download terminated incorrectly.

Changes in Ver.1.86
--------------------
- Renew process again to fix file transfer sometimes did not start 
  or stop.
- Disable strip host name feature added on 1.83.
- Support Windows XP's theme.
- Fixed display wrong format when file name has "&" character.
- Add No RAS Control option.
- Change path separater character to ">" when Stratus.
- Support OS9 server subfolder.
- Support server that replies following file list.
    -rwxrwxrwx SEQ 36203776 01/07/07 12:38:28 ABCDEFG
- Support server that replies following file list. (IBM server)
    MTS940 3390   2001/07/26  1    1  FB      80  3120  PS  FTPOUT.CNTL
- Support hidden drives.

Changes in Ver.1.85
--------------------
- Fixed file transfer sometimes did not start or stop.

Changes in Ver.1.84
--------------------
- Fixed file transfer sometimes did not start or stop.
- Fixed high CPU usage.
- Change anonymous FTP list.

Changes in Ver.1.83
--------------------
- You can type folder name into current folder window now.
- You can now copy log data with mouse dragging.
- Support server that replies file list which has any characters after 
  the owner and the group name.
- Strip host name when the URL enterd into host name window.
- Fixed freez until timeout when network is heavy.
- Fixed FFFTP did not terminate normally until file transfer is in 
  progress.

Changes in Ver.1.82
--------------------
- Use XPWD command first to get current folder.
- Add folder list button on change local folder dialog.
- Add -n command line option. (See ffftp -h)
- Support server that replies date string such as "5/14".
- Support OS9 server. (without sub-directory support)

Changes in Ver.1.81
--------------------
- File list that containes Ctrl-H are now displaied.
- Show error reason when file transfer error occured.
- Copying URL to clipboard include port number.
- Add default permission for folder.
- Fixed file date becomes future.

Changes in Ver.1.80
--------------------
- Fixed Ctrl-Shift-D did not work to start mirroring download.
- Change default setting to use INI file.
- Give priority to use INI file when both INI and Registory settings
  are existing.

Changes in Ver.1.79a
--------------------
- First English version.

